/* This file was automatically generated.  Do not edit! */
typedef struct fadv fadv;
#if !(defined(HAVE_POSIX_FADVISE))
#define fadv_purge(a, l)   ((a)->fd = 0)
#endif
#if defined(HAVE_POSIX_FADVISE)
void fadv_purge(struct fadv *a,int length);
#define fadv_close(a) fadv_purge(a, -1)
#endif
#if !(defined(HAVE_POSIX_FADVISE))
#define fadv_close(a)      ((a)->fd = 0)
#endif
#if defined(HAVE_POSIX_FADVISE)
#define fadv_init(a, f, o) do {\
    (a)->fd = f;\
    (a)->chunk = 0;\
    (a)->offset = o;\
  } while(0)
#endif
#if !(defined(HAVE_POSIX_FADVISE))
#define fadv_init(a, f, o) ((a)->fd = 0)
#endif
struct fadv {
  int fd;
  int chunk;
  guint64 offset;
};
void logfile_global_reopen();
typedef struct logfile logfile;
void logfile_add(struct logfile *l,const char *msg);
void logfile_free(struct logfile *l);
struct logfile *logfile_create(const char *name);
struct logfile {
  FILE *file;
  char *path;
  struct stat st;
};
typedef struct ratecalc ratecalc;
char *ratecalc_eta(struct ratecalc *rc,guint64 left);
extern GSList *ratecalc_list;
#define ratecalc_calc() do {\
    GSList *n; int cur; struct ratecalc *rc;\
    for(n=ratecalc_list; n; n=n->next) {\
      rc = n->data;\
      do {\
        cur = g_atomic_int_get(&(rc->counter));\
      } while(!g_atomic_int_compare_and_exchange(&(rc->counter), cur, 0));\
      rc->total += cur;\
      rc->rate = cur + ((rc->rate - cur) / 2);\
    }\
  } while(0)
#define ratecalc_get(rc) ((rc)->rate)
#define ratecalc_register(rc) do { if(!(rc)->isreg) {\
    ratecalc_list = g_slist_prepend(ratecalc_list, rc);\
    (rc)->isreg = 1;\
  } } while(0)
#define ratecalc_unregister(rc) do {\
    ratecalc_list = g_slist_remove(ratecalc_list, rc);\
    (rc)->isreg = (rc)->rate = 0;\
  } while(0)
#define ratecalc_reset(rc) do {\
    g_atomic_int_set(&((rc)->counter), 0);\
    (rc)->rate = (rc)->total = 0;\
  } while(0)
#define ratecalc_init(rc) do {\
    ratecalc_unregister(rc);\
    ratecalc_reset(rc);\
  } while(0)
#define ratecalc_add(rc, b) g_atomic_int_add(&((rc)->counter), b)
struct ratecalc {
  int counter;
  int rate;
  guint64 total;
  char isreg;
};
#define ip4_cmp(a, b) ((a) > (b) ? 1 : -1)
char *ip4_unpack(guint32 ip);
guint32 ip4_pack(const char *str);
#define isbase32(s) (strspn(s, "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ234567") == strlen(s))
#define istth(s) (strlen(s) == 39 && isbase32(s))
char **file_tail(const char *fn,int n);
void path_suggest(char *opath,char **sug);
int cmpstringp(const void *p1,const void *p2);
char *path_expand(const char *path);
gboolean tiger_hash_equal(gconstpointer a,gconstpointer b);
guint64 connection_to_speed(const char *conn);
gboolean is_valid_hubname(const char *name);
void ptr_array_insert_before(GPtrArray *a,int i,gpointer v);
int ptr_array_search(GPtrArray *a,gpointer v,GCompareFunc cmp);
void str_arg2_split(char *str,char **first,char **second);
void strv_prefix(char **arr,const char *str,...);
int str_parseinterval(const char *str);
char *str_formatinterval(int sec);
guint64 str_parsesize(const char *str);
char *str_casestr(const char *haystack,const char *needle);
char *str_fullsize(guint64 size);
char *str_formatsize(guint64 size);
int str_offset_from_columns(const char *str,int col);
int str_columns(const char *str);
gboolean str_convert_check(const char *fmt,GError **err);
char *str_convert(const char *to,const char *from,const char *str);
void conf_group_rename(const char *from,const char *to);
extern int fadv_enabled;
void base32_decode(const char *from,char *to);
void conf_save();
void conf_init();
void base32_encode(const char *from,char *to);
guint64 rand_64();
void base32_encode_dat(const char *from,char *to,int len);
#if TLS_SUPPORT
void certificate_sha256(GTlsCertificate *cert,char *digest);
#endif
extern char *conf_certificate_kp;
extern char *conf_tlsp_list[];
#if TLS_SUPPORT
extern GTlsCertificate *conf_certificate;
#endif
#if !(TLS_SUPPORT)
extern char *conf_certificate;
#endif
#define CONF_TLSP_DISABLE 0
extern GKeyFile *conf_file;
#define CONF_TLSP_ALLOW   1
#define conf_tls_policy(hub) (\
  !conf_certificate ? CONF_TLSP_DISABLE\
    : g_key_file_has_key(conf_file, hub, "tls_policy", NULL)\
    ? g_key_file_get_integer(conf_file, hub, "tls_policy", NULL)\
    : g_key_file_has_key(conf_file, "global", "tls_policy", NULL)\
    ? g_key_file_get_integer(conf_file, "global", "tls_policy", NULL)\
    : CONF_TLSP_ALLOW)
#define CONF_TLSP_PREFER  2
#define conf_filelist_maxage() (\
  !g_key_file_has_key(conf_file, "global", "filelist_maxage", NULL) ? (7*24*3600) \
    : g_key_file_get_integer(conf_file, "global", "filelist_maxage", NULL))
#define conf_ui_time_format() (\
  !g_key_file_has_key(conf_file, "global", "ui_time_format", NULL) ? g_strdup("[%H:%M:%S]")\
    : g_key_file_get_string(conf_file, "global", "ui_time_format", NULL))
#define conf_log_debug() (\
  !conf_file ? TRUE : !g_key_file_has_key(conf_file, "log", "log_debug", NULL) ? FALSE :\
    g_key_file_get_boolean(conf_file, "log", "log_debug", NULL))
extern const char *conf_dir;
#define conf_incoming_dir() (\
  !g_key_file_has_key(conf_file, "global", "incoming_dir", NULL) ? g_build_filename(conf_dir, "inc", NULL)\
    : g_key_file_get_string(conf_file, "global", "incoming_dir", NULL))
#define conf_download_slots() (\
  !g_key_file_has_key(conf_file, "global", "download_slots", NULL) ? 3\
    : g_key_file_get_integer(conf_file, "global", "download_slots", NULL))
#define conf_download_dir() (\
  !g_key_file_has_key(conf_file, "global", "download_dir", NULL) ? g_build_filename(conf_dir, "dl", NULL)\
    : g_key_file_get_string(conf_file, "global", "download_dir", NULL))
#define conf_minislot_size() (1024*(\
  !g_key_file_has_key(conf_file, "global", "minislot_size", NULL) ? 64\
    : g_key_file_get_integer(conf_file, "global", "minislot_size", NULL)))
#define conf_minislots() (\
  !g_key_file_has_key(conf_file, "global", "minislots", NULL) ? 3\
    : g_key_file_get_integer(conf_file, "global", "minislots", NULL))
#define conf_slots() (\
  !g_key_file_has_key(conf_file, "global", "slots", NULL) ? 10\
    : g_key_file_get_integer(conf_file, "global", "slots", NULL))
#define conf_autorefresh() (\
  !g_key_file_has_key(conf_file, "global", "autorefresh", NULL) ? 60\
    : g_key_file_get_integer(conf_file, "global", "autorefresh", NULL))
#define conf_encoding(hub) (\
  g_key_file_has_key(conf_file, hub, "encoding", NULL)\
    ? g_key_file_get_string(conf_file, hub, "encoding", NULL) \
    : g_key_file_has_key(conf_file, "global", "encoding", NULL) \
    ? g_key_file_get_string(conf_file, "global", "encoding", NULL) \
    : g_strdup("UTF-8"))
#define conf_hub_get(type, name, key) (\
  g_key_file_has_key(conf_file, name, (key), NULL)\
    ? g_key_file_get_##type(conf_file, name, (key), NULL)\
    : g_key_file_get_##type(conf_file, "global", (key), NULL))
extern char conf_pid[24];
extern char conf_cid[24];
#define gunichar_width(x) (g_unichar_iswide(x) ? 2 : g_unichar_iszerowidth(x) ? 0 : 1)
#define loglevel_to_str(level) (\
  (level) & G_LOG_LEVEL_ERROR    ? "ERROR"    :\
  (level) & G_LOG_LEVEL_CRITICAL ? "CRITICAL" :\
  (level) & G_LOG_LEVEL_WARNING  ? "WARNING"  :\
  (level) & G_LOG_LEVEL_MESSAGE  ? "message"  :\
  (level) & G_LOG_LEVEL_INFO     ? "info"     : "debug")
#define INTERFACE 0
